#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <time.h>
#include <things.h>
void (*_SigStart)(void) = NULL;

typedef struct
{
    char path[40];
    time_t stamp;
} FAXITEM;

typedef struct
{
    int  flag;
    int  type;
    short maxitems;
    short current;
    short nitems;
    FAXITEM fdata[1];
} FAX_LIST;

extern char *_endmsg = NULL;

static char *Stuff = "QFAX Items";
#define STUFF_SIZE 10
 
void AddFaxList (char *path, time_t tim, char *fnam)
{
    THING_LINKAGE *p = NULL;    
    long  vers = 0;
    void *q;
    int sts;

    sts = (int) sms_uthg (Stuff, -1, -1, NULL, NULL, &vers, &p);

    if(sts == 0)
    {
        short pos;
        FAX_LIST *f = (FAX_LIST *)p->th_thing;

        _super();
        pos = (f->current + 1) % f->maxitems;
        if(f->nitems < f->maxitems)
        {
            f->nitems++;
        }
        strcpy(f->fdata[f->current].path, path);
        f->fdata[f->current].stamp = tim;
        f->current = pos;
        _user();    
        if(fnam)
        {
            int chid;
            short i;

            /* Do this a la QDOS for minimal size in other apps. */
            
            if((chid = io_open(fnam, 3)) > 0)
            {
                io_sstrg (chid, -1, f, (2*sizeof(int) + sizeof(short)));
                io_sstrg (chid, -1, &f->nitems, sizeof(short));
                io_sstrg (chid, -1, &f->nitems, sizeof(short));

        	for (i = 0; i < f->nitems; i++, pos++)
	        {
                    pos = pos % f->nitems;
                    io_sstrg (chid, -1, &(f->fdata[pos]), sizeof(FAXITEM));
                }
                io_close(chid);
            }
        }
        sms_fthg (Stuff, -1, NULL, 0, NULL, NULL);
    }
}

int main(int ac, char **av)
{
    int c;
    int i;
    char *fnm = NULL, *savefile = NULL;
    char ucmd[128];
    *ucmd = 0;
    
    for (i = 1; i < ac; i++)
    {
        if((c = *av[i]) == '-')
        {
            switch(*++av[i])
            {
                case 'f':
                    if(*++av[i])
                    {
                        fnm = av[i];
                    }
                    else
                    {
                        fnm = av[++i];
                    }
                    break;
                case 's':
                    if(*++av[i])
                    {
                        savefile = av[i];
                    }
                    else
                    {
                        savefile = av[++i];
                    }
                    break;
            }
        }
        else
        {
            break;
        }
    }

    while(i < ac)
    {
        strcat(ucmd, av[i++]);
        strcat(ucmd, " ");
    }

    puts(fnm);
    
    if(fnm)
    {
        AddFaxList (fnm, mt_rclck(), savefile);
    }
    
    if(*ucmd)
    {    
        system (ucmd);
    }
}
