#include <stdio.h>
#include <string.h>
#include <qdos.h>
#include "qheader.h"
#include "qfaxparse.h"
#include "qfax.h"

extern FAXDATA qd;

typedef struct
{
    char    *prog;
    char    *comstr;
    long    inchid;
    long    ouchid;
    long    owner;
    long    stde;
    char    prio;
    char    wait;
} QFORK;

extern int qfork(QFORK *);

int qsystem(int pser, char *cmd, int stde)
{
    QFORK qf;
    char *p = NULL, *q = NULL;

    if(p = strchr(cmd, ' '))
    {
        *p = 0;
        q = p + 1;
    }
    
    qf.prog = cmd;
    qf.comstr = q;
    qf.inchid = qf.ouchid = pser;
    qf.stde = stde;
    qf.owner = -1;
    qf.prio = 16;
    qf.wait = -1;
    if(qf.stde > 0)
    {
        qfork(&qf);
    }
    if(p)
    {
        *p = ' ';
    }
    return 0;
}
