typedef struct
{
    unsigned short attr;
    unsigned short info;
    void *ptr;
} MENUP;

typedef struct
{
    MENUP   mennm;
    MENUP   defnm;
    MENUP   dirnm;
    MENUP   extnm;
    long    size;
    long    xpos;
    long    ypos;
    long    manic;
    long    filec;
    MENUP   fname;
} MENUFS;


#define THP_UPD     0xe000
#define THP_CALL    0xc000
#define THP_RET     0xa000
#define THP_PTR     0x8000
#define THP_OPT     0x1000

#define THP_CHAR    0x0004
#define THP_UBYT    0x0008
#define THP_SBYT    0x000a
#define THP_UWRD    0x0010
#define THP_SWRD    0x0012
#define THP_ULNG    0x0020
#define THP_SLNG    0x0022
#define THP_FP8     0x0042
#define THP_STR     0x0100
#define THP_SSTR    0x0200

