#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>

#define DEFX 16
#define DEFY 28
#define DEFFONT "/root/.qfax.font"
#define DEFSIZE 14336

typedef struct
{
    char flag[8];
    short xpix;
    short ypix;
    unchar top_l;
    unchar bot_l;
    unchar right;
    unchar fill;
    unchar font[2];
} QFONT;

int main(void)
{
    int fd,fx;
    QFONT *qfont;
    unchar *oft;
    size_t qfs;
    
    fd = open(DEFFONT, O_RDONLY, 0);
    if(fd < 0)
    {
	perror("open");
	exit(0);
    }
    fx = open("qfax2.font", O_CREAT|O_TRUNC|O_WRONLY);
    if(fx < 0)
    {
	perror("creat");
	exit(0);
    }

    qfs = sizeof(QFONT)-2+DEFSIZE*4;

    if(qfont = malloc(qfs))
    {
	if(oft = malloc(DEFSIZE))
	{
	    unchar *p,*q;
	    short i,j,k,l;
	    static unchar mask[] = {0x80,0x40,0x20,0x10,8,4,2,1};

	    memcpy(qfont->flag,"QfaxFont", 8);
	    qfont->xpix = 0x2000;
	    qfont->ypix = 0x3800;
	    qfont->top_l = 4;
	    qfont->bot_l = 6;
	    qfont->right = 2;

	    p = oft;
	    read(fd, p, DEFSIZE);
	    q = qfont->font;

	    for(i = 0; i < 256; i++)
	    {
		for(j = 0; j < DEFY; j++)
		{
		    for(k = 0; k < DEFX; k++,l += 2)
		    {
			if(k == 8)
			{
			    p++;
			}

			if(l == 8)
			{
			    l = 0;
			    *(q+4) = *q;
			    q++;
			}
			
			if(*p & mask[k&7])
			{
			    *q |= mask[l];
			    *q |= mask[l+1];
			}
		    }
		    *(q+4) = *q;
		    q++; l = 0;
		    q += 4;
		    p++;
		}
	    }
    {
	int n;
	n = write(fx, qfont, qfs);
	printf("write %d %d\n", n, (q - qfont->font));
    }

	}
	
    }
    return 0;
}




